/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#include <project.h>
#include <i2c_functions.h>
#include <stdbool.h>
#include <stdio.h>
//Some definitions
#define DEFAULT_ADDR  (0x62)

void lidarLite_conf (int configuration) {
  switch(configuration)
  {
    case 0:
      write_byte_to_register(DEFAULT_ADDR,0x02,0x80);
      write_byte_to_register(DEFAULT_ADDR,0x04,0x08);
      write_byte_to_register(DEFAULT_ADDR,0x1c,0x00);
    break;
    
    case 1:
      write_byte_to_register(DEFAULT_ADDR,0x02,0x1d);
      write_byte_to_register(DEFAULT_ADDR,0x04,0x08);
      write_byte_to_register(DEFAULT_ADDR,0x1c,0x00);
    break;
    
    case 2:
      write_byte_to_register(DEFAULT_ADDR,0x02,0x80);
      write_byte_to_register(DEFAULT_ADDR,0x04,0x00);
      write_byte_to_register(DEFAULT_ADDR,0x1c,0x00);
    break;
    
    case 3:
      write_byte_to_register(DEFAULT_ADDR,0x02,0xff);
      write_byte_to_register(DEFAULT_ADDR,0x04,0x08);
      write_byte_to_register(DEFAULT_ADDR,0x1c,0x00);
    break;
    
    case 4:
      write_byte_to_register(DEFAULT_ADDR,0x02,0x80);
      write_byte_to_register(DEFAULT_ADDR,0x04,0x08);
      write_byte_to_register(DEFAULT_ADDR,0x1c,0x80);
    break;
    
    case 5:
      write_byte_to_register(DEFAULT_ADDR,0x02,0x80);
      write_byte_to_register(DEFAULT_ADDR,0x04,0x08);
      write_byte_to_register(DEFAULT_ADDR,0x1c,0x80);
    break;
  }
}

void lidarLite_reset(){
  write_byte_to_register(DEFAULT_ADDR,0x00,0x00);
}


int lidarLite_distance (bool biasCorrection) {
//Distance will be returned in m
  if(biasCorrection) {
    write_byte_to_register(DEFAULT_ADDR,0x00,0x04);
  }
  else {
    write_byte_to_register(DEFAULT_ADDR,0x00,0x03);
  }
  //Read register 0x01 and repeat until LSB bit = 0 
  
  uint8 readByte[1] ={1};
  uint8 rdData[1]={1};
    //int readInt = (int)readByte[0];
    
    uint8 check=1;
  while (check != 0) {
    read_from_register(DEFAULT_ADDR,0x01, (uint8 *)rdData, 1);
    check=rdData[0] & 1;
    //int readInt = (int)readByte[0];   
}

//Read bytes from 0x8f 
    uint8 readData[2];
    uint8 reg=0x8f;
    read_from_register(DEFAULT_ADDR, reg, (uint8 *)readData,2);

    
    int distance = (readData[0] << 8) + readData[1];
    //float Distance = (float) distance/100.00;
    
 return distance;
}



/* [] END OF FILE */
