/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/
#include <project.h>
#include <i2c_functions.h>


void read_from_register (uint8 slave_address, uint8 reg, uint8 * rdData, size_t numBytes) {
    
    I2C_MasterSendStart(slave_address, I2C_WRITE_XFER_MODE);
    I2C_MasterWriteByte(reg);
    I2C_MasterSendStop();
    
    //Read all bytes
    I2C_MasterSendStart(slave_address, I2C_READ_XFER_MODE);
    size_t count=0;
    while (count < numBytes) {
       if (count == (numBytes-1)){
        rdData[count]=I2C_MasterReadByte(I2C_NAK_DATA);
       }
       else {
        rdData[count]=I2C_MasterReadByte(I2C_ACK_DATA);
    }
       count++;
    }
    I2C_MasterSendStop();
    
}

//WRITE FUNCTION
void write_byte_to_register (uint8 slave_address, uint8 reg, uint8 value) {
   
   I2C_MasterSendStart(slave_address, I2C_WRITE_XFER_MODE);
   I2C_MasterWriteByte(reg);
   I2C_MasterWriteByte(value);
   
   I2C_MasterSendStop();
   
   CyDelay(1);
   return;
}
/* [] END OF FILE */
